apiVersion: apps/v1
kind: Deployment
metadata:
  name: devops
  namespace: {{ .Values.ci_commit_branch }}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: devops
  template:
    metadata:
      labels:
        app: devops
    spec:
      containers:
#      - env:
#        - name: SPRING_DATASOURCE_PASSWORD
#          value: P@ssw0rd
#        - name: SPRING_DATASOURCE_URL
#          value: jdbc:mysql://mysql:3306/assignment?allowPublicKeyRetrieval=true
#        - name: SPRING_DATASOURCE_USERNAME
#          value: user1
#        - name: dbprofile
#        - name: javaopts
#          value: -Xms256m -Xmx512m
      - image: "{{ .Values.image.repo }}/{{ .Values.image.imageName }}:{{ .Values.image.tag }}"
        imagePullPolicy: ""
        name: devops
        env:
          - name: SPRING_DATASOURCE_PASSWORD
            valueFrom:
              secretKeyRef:
                name: db-secret
                key: password
          - name: SPRING_DATASOURCE_URL
            value: jdbc:mysql://mysql:3306/assignment?allowPublicKeyRetrieval=true
          - name: SPRING_DATASOURCE_USERNAME
            valueFrom:
              secretKeyRef:
                name: db-secret
                key: username 
          - name: dbprofile
          - name: javaopts
            value: -Xms256m -Xmx512m
          - name: SPECIAL_LEVEL_KEY
            valueFrom:
              configMapKeyRef:
                name: special-config
                key: CHECK_SQL
         # - chmod +x ../app/checkmysql.sh && sh ../app/checkmysql.sh
        ports:
        - containerPort: 8090
        resources:
          requests:
            memory: "64Mi"
            cpu: "250m"
          limits:
            memory: "128Mi"
            cpu: "500m"
        livenessProbe:
          httpGet:
            path: /actuator/health
            port: 8090
          initialDelaySeconds: 10
          periodSeconds: 5
          failureThreshold: 60
        readinessProbe:
          tcpSocket:
            port: 8090
          initialDelaySeconds: 10
          periodSeconds: 5
          failureThreshold: 60    
      initContainers:
        - name: init-devops
          image: busybox:1.28
          env:
            - name: SPECIAL_LEVEL_KEY
              valueFrom:
                configMapKeyRef:
                  name: special-config
                  key: CHECK_SQL
          command: 
            - sh
            - -c
            - $(SPECIAL_LEVEL_KEY)  
      restartPolicy: Always
